/*  GREATIS FORM DESIGNER FOR .NET           */
/*  Copyright (C) 2004-2014 Greatis Software */
/*  http://www.greatis.com/dotnet/formdes/   */
/*  http://www.greatis.com/bteam.html        */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Windows.Forms;

namespace DragDemoCS
{
   /// <summary>
   /// Summary description for PropertyWindow.
   /// </summary>
   public class PropertyWindow : System.Windows.Forms.Form
   {
      private Greatis.FormDesigner.Designer designer = null;

      private System.Windows.Forms.PropertyGrid propertyGrid1;
      /// <summary>
      /// Required designer variable.
      /// </summary>
      private System.ComponentModel.Container components = null;

      public PropertyWindow()
      {
         //
         // Required for Windows Form Designer support
         //
         InitializeComponent();

         //
         // TODO: Add any constructor code after InitializeComponent call
         //
         propertyGrid1.SelectedObjectsChanged += new EventHandler(SelectedObjectsChanged);
     }

     void SelectedObjectsChanged(object sender, EventArgs e)
     {
         if (propertyGrid1.SelectedObjects.Length == 0)
             propertyGrid1.SelectedObject = designer.DesignedForm;
     }

     internal Greatis.FormDesigner.Designer Designer
     {
         set
         {
            if (value != null)
            {
               designer = value;
               ISelectionService ss = (ISelectionService)value.DesignerHost.GetService(typeof(ISelectionService));
               ss.SelectionChanged += new EventHandler(SelectionChanged);

               propertyGrid1.SelectedObject = designer.DesignedForm;
               propertyGrid1.Site = new PropertyGridSite(value.DesignerHost as IServiceProvider);
            }
            else
            {
               propertyGrid1.Site = null;
               if (designer != null)
               {
                  ISelectionService ss = (ISelectionService)designer.DesignerHost.GetService(typeof(ISelectionService));
                  ss.SelectionChanged -= new EventHandler(SelectionChanged);
                  designer = null;
               }
               propertyGrid1.SelectedObject = null;
            }
         }
      }

      private void SelectionChanged(object sender, EventArgs e)
      {
         ISelectionService ss = (ISelectionService)designer.DesignerHost.GetService(typeof(ISelectionService));
         if (ss.SelectionCount == 0)
            propertyGrid1.SelectedObject = designer.DesignedForm;
         else
         {
            object[] selected = new object[ss.SelectionCount];
            ss.GetSelectedComponents().CopyTo(selected, 0);
            propertyGrid1.SelectedObjects = selected;

            ((System.Windows.Forms.Control)selected[0]).Focus();
         }
      }

      /// <summary>
      /// Clean up any resources being used.
      /// </summary>
      protected override void Dispose( bool disposing )
      {
         if( disposing )
         {
            if(components != null)
            {
               components.Dispose();
            }
         }
         base.Dispose( disposing );
      }

      #region Windows Form Designer generated code
      /// <summary>
      /// Required method for Designer support - do not modify
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent()
      {
         this.propertyGrid1 = new System.Windows.Forms.PropertyGrid();
         this.SuspendLayout();
         // 
         // propertyGrid1
         // 
         this.propertyGrid1.CommandsVisibleIfAvailable = true;
         this.propertyGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
         this.propertyGrid1.LargeButtons = false;
         this.propertyGrid1.LineColor = System.Drawing.SystemColors.ScrollBar;
         this.propertyGrid1.Location = new System.Drawing.Point(0, 0);
         this.propertyGrid1.Name = "propertyGrid1";
         this.propertyGrid1.Size = new System.Drawing.Size(292, 266);
         this.propertyGrid1.TabIndex = 0;
         this.propertyGrid1.Text = "propertyGrid1";
         this.propertyGrid1.ViewBackColor = System.Drawing.SystemColors.Window;
         this.propertyGrid1.ViewForeColor = System.Drawing.SystemColors.WindowText;
         // 
         // PropertyWindow
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.ClientSize = new System.Drawing.Size(292, 266);
         this.Controls.Add(this.propertyGrid1);
         this.Name = "PropertyWindow";
         this.ShowInTaskbar = false;
         this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
         this.Text = "Properties";
         this.ResumeLayout(false);

      }
      #endregion
   }

   /// A nearly empty implementation of ISite, this class merely passes on
   /// service requests to the host.
   public class PropertyGridSite : System.ComponentModel.ISite
   {
      private IServiceProvider sp;

      public PropertyGridSite(IServiceProvider sp)
      {
         this.sp = sp;
      }
      #region Implementation of ISite

      public System.ComponentModel.IComponent Component
      {
         get { return null; }
      }

      public System.ComponentModel.IContainer Container
      {
         get { return null; }
      }

      public bool DesignMode
      {
         get { return false; }
      }

      public string Name
      {
         get { return null; }
         set { }
      }

      #endregion

      #region Implementation of IServiceProvider

      public object GetService(Type serviceType)
      {
         if (sp != null)
            return sp.GetService(serviceType);

         return null;
      }

      #endregion
   }
}
