/*  GREATIS FORM DESIGNER FOR .NET           */
/*  Copyright (C) 2004-2014 Greatis Software */
/*  http://www.greatis.com/dotnet/formdes/   */
/*  http://www.greatis.com/bteam.html        */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.ComponentModel.Design;

using Greatis.FormDesigner;

namespace FloatCS
{
   /// <summary>
   /// Summary description for PropertyWindow.
   /// </summary>
   public class PropertyWindow : System.Windows.Forms.Form
   {
      private System.Windows.Forms.PropertyGrid propertyGrid;
      /// <summary>
      /// Required designer variable.
      /// </summary>
      private System.ComponentModel.Container components = null;

      private Greatis.FormDesigner.Designer designer = null;

      public PropertyWindow()
      {
         //
         // Required for Windows Form Designer support
         //
         InitializeComponent();

         //
         // TODO: Add any constructor code after InitializeComponent call
         //
         propertyGrid.SelectedObjectsChanged += new EventHandler(SelectedObjectsChanged);
     }

     void SelectedObjectsChanged(object sender, EventArgs e)
     {
         if (propertyGrid.SelectedObjects.Length == 0 && designer != null)
             propertyGrid.SelectedObject = designer.DesignedForm;
     }

     internal Greatis.FormDesigner.Designer Designer
      {
         set
         {
            if (value != null)
            {
               designer = value;
               ISelectionService ss = (ISelectionService)value.DesignerHost.GetService(typeof(ISelectionService));
               ss.SelectionChanged += new EventHandler(SelectionChanged);

               propertyGrid.SelectedObject = designer.DesignedForm;
               propertyGrid.Site = new PropertyGridSite(value.DesignerHost as IServiceProvider);
            }
            else
            {
               propertyGrid.Site = null;
               if (designer != null)
               {
                  ISelectionService ss = (ISelectionService)designer.DesignerHost.GetService(typeof(ISelectionService));
                  ss.SelectionChanged -= new EventHandler(SelectionChanged);
                  designer = null;
               }
               propertyGrid.SelectedObject = null;
            }
         }
      }

      /// <summary>
      /// Clean up any resources being used.
      /// </summary>
      protected override void Dispose(bool disposing)
      {
         if (disposing)
         {
            if (components != null)
            {
               components.Dispose();
            }
         }
         base.Dispose(disposing);
      }

      private void SelectionChanged(object sender, EventArgs e)
      {
         ISelectionService ss = (ISelectionService)designer.DesignerHost.GetService(typeof(ISelectionService));
         if (ss.SelectionCount == 0)
            propertyGrid.SelectedObject = designer.DesignedForm;
         else
         {
            object[] selected = new object[ss.SelectionCount];
            ss.GetSelectedComponents().CopyTo(selected, 0);
            propertyGrid.SelectedObjects = selected;
         }
      }

      #region Windows Form Designer generated code
      /// <summary>
      /// Required method for Designer support - do not modify
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent()
      {
         this.propertyGrid = new System.Windows.Forms.PropertyGrid();
         this.SuspendLayout();
         // 
         // propertyGrid
         // 
         this.propertyGrid.CommandsVisibleIfAvailable = true;
         this.propertyGrid.CausesValidation = false;
         this.propertyGrid.Dock = System.Windows.Forms.DockStyle.Fill;
         this.propertyGrid.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.propertyGrid.LargeButtons = false;
         this.propertyGrid.LineColor = System.Drawing.SystemColors.ScrollBar;
         this.propertyGrid.Location = new System.Drawing.Point(0, 0);
         this.propertyGrid.Name = "propertyGrid";
         this.propertyGrid.Size = new System.Drawing.Size(233, 281);
         this.propertyGrid.TabIndex = 0;
         this.propertyGrid.Text = "propertyGrid1";
         this.propertyGrid.ViewBackColor = System.Drawing.SystemColors.Window;
         this.propertyGrid.ViewForeColor = System.Drawing.SystemColors.WindowText;
         // 
         // PropertyWindow
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.ClientSize = new System.Drawing.Size(233, 281);
         this.Controls.Add(this.propertyGrid);
         this.Font = new System.Drawing.Font("Tahoma", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
         this.Name = "PropertyWindow";
         this.ShowInTaskbar = false;
         this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
         this.Text = "Properties";
         this.ResumeLayout(false);

      }
      #endregion
   }
   /// A nearly empty implementation of ISite, this class merely passes on
   /// service requests to the host.
   internal class PropertyGridSite : System.ComponentModel.ISite
   {
      private IServiceProvider sp;

      public PropertyGridSite(IServiceProvider sp)
      {
         this.sp = sp;
      }
      #region Implementation of ISite

      public System.ComponentModel.IComponent Component
      {
         get { return null; }
      }

      public System.ComponentModel.IContainer Container
      {
         get { return null; }
      }

      public bool DesignMode
      {
         get { return false; }
      }

      public string Name
      {
         get { return null; }
         set { }
      }

      #endregion

      #region Implementation of IServiceProvider

      public object GetService(Type serviceType)
      {
         if (sp != null)
            return sp.GetService(serviceType);

         return null;
      }

      #endregion
   }
}
